MODULE BasDem1;

IMPORT SSWiS, BasicLib;
FROM   SYSTEM IMPORT ADDRESS, VAL, SHORT;

VAR ScrInfo         : BasicLib.ScreenRec;
    Screen          : ADDRESS;
    WWidth, BWidth,
    Height10        : CARDINAL;
    Adr             : ADDRESS;
    i, j, n,
    I, J, X, Y      : CARDINAL;
    Size10, Size100,
    x, y            : LONGCARD;
    Button          : INTEGER;
    Set             : ARRAY [0..959] OF BOOLEAN;
    GetPut          : ARRAY [1..16], [1..10] OF BasicLib.SCREEN1;
    EnoughMemory    : BOOLEAN;

BEGIN
  BasicLib.ScreenInfo (ScrInfo);
  IF ScrInfo.ScreenRes # BasicLib.High THEN
     BasicLib.ALERT (3, 'BasDem1 luft nur in|hoher Bildschirmauflsung !',
                     1, ' Ende ', Button);
     RETURN
  END;

  WWidth   := ScrInfo.ScreenWidth DIV 16;
  BWidth   := WWidth * 2;
  Size10   := ScrInfo.ScreenSize DIV 10D;
  Size100  := ScrInfo.ScreenSize DIV 100D;
  Height10 := ScrInfo.ScreenHeight DIV 10;

  BasicLib.SGET (Screen);
  IF BasicLib.ERROR # 0 THEN  RETURN  END;
      
  SSWiS.Close;
  BasicLib.HIDEM;
  BasicLib.CLS;

  (* Jalousie: *)
  FOR n := 2 TO 0 BY -1 DO
    FOR i := 0 TO Height10 - 1 DO
      x := VAL (LONGCARD, i * Height10 * 2);
      FOR j := 0 TO 9 DO
        y := VAL (LONGCARD, j) * Size10 + x;
        BasicLib.BMOVE (Screen + VAL(ADDRESS, y),
                        ScrInfo.PhysBase + VAL(ADDRESS, y), BWidth)
      END;
      BasicLib.PAUSE (n)
    END;
    BasicLib.PAUSE (20);
    BasicLib.CLS
  END;

  (* Brsel: *)
  FOR n := 200 TO 0 BY -100 DO
    BasicLib.ARRAYFILLb (Set, 0C);
    i := 0;
    REPEAT
      j := BasicLib.RANDOM (ScrInfo.ScreenHeight);
      IF ~Set[j] THEN
         Set[j] := TRUE;
         x := VAL (LONGCARD, j * BWidth);
         BasicLib.BMOVE (Screen + VAL(ADDRESS, x),
                         ScrInfo.PhysBase + VAL(ADDRESS, x), BWidth);
         INC (i)
      END;
      FOR j := 1 TO n DO  END
    UNTIL i = ScrInfo.ScreenHeight;
    BasicLib.PAUSE (20);
    BasicLib.CLS
  END;

  (* Reinschieben: *)
  Adr := Screen + VAL (ADDRESS, ScrInfo.ScreenSize);
  I   := ScrInfo.ScreenHeight DIV 400;
  i   := 1;
  WHILE i <= ScrInfo.ScreenHeight DO
    x := VAL (LONGCARD, i * BWidth);
    BasicLib.BMOVE (Adr - VAL(ADDRESS, x), ScrInfo.PhysBase, x);
    INC (i, I)
  END;
  BasicLib.PAUSE (50);
  BasicLib.CLS;

  (* Linien: *)
  J := (ScrInfo.ScreenHeight DIV 400) * 2;
  FOR i := ScrInfo.ScreenHeight - 4 TO 0 BY -4 DO
    Adr := Screen + VAL (ADDRESS, i * BWidth);
    j := 0;
    WHILE j <= i DO
      BasicLib.BMOVE (Adr, ScrInfo.PhysBase + VAL(ADDRESS, j*BWidth), Size100);
      INC (j, J)
    END
  END;
  BasicLib.FreeScr2 (Screen);

  (* Rechtecke: *)
  X := ScrInfo.ScreenWidth  DIV 16;
  Y := ScrInfo.ScreenHeight DIV 10;
  EnoughMemory := TRUE;
  FOR i := 0 TO 15 DO
    FOR j := 0 TO 9 DO
      IF BasicLib.ERROR = 0 THEN
         BasicLib.GET (GetPut[i+1,j+1], i*X, j*Y, i*X+X-1, j*Y+Y-1)
      ELSIF EnoughMemory THEN
         EnoughMemory := FALSE;
         I := i + 1;  J := j - 1;
      END
    END
  END;

  IF EnoughMemory THEN
     (* Rechtecke-1: *)
     BasicLib.CLS;
     FOR j := 1 TO 10 DO
       FOR i := 1 TO 16 DO
         BasicLib.PAUSE (1);
         BasicLib.PUT (GetPut[i,j], (i-1)*X, (j-1)*Y, 12, FALSE);
         BasicLib.PAUSE (2);
         BasicLib.PUT (GetPut[i,j], (i-1)*X, (j-1)*Y, 3, FALSE)
       END
     END;
   
     (* Rechtecke-2: *)
     BasicLib.CLS;
     FOR i := 1 TO 16 BY 2 DO
       FOR j := 1 TO 10 DO
         BasicLib.PAUSE (2);
         BasicLib.PUT (GetPut[i,j],   (i-1)*X, (j-1)*Y, 3, TRUE);
         BasicLib.PUT (GetPut[i+1,j], i*X, (j-1)*Y, 3, TRUE)
       END
     END;
     BasicLib.PAUSE (100)
  ELSE
     FOR i := I TO 1 BY -1 DO
       FOR j := J TO 1 BY -1 DO
         BasicLib.FreeScr1 (GetPut[i,j])
       END;
       J := 10
     END
  END;

  BasicLib.SHOWM;
  BasicLib.ALERT (3, ' |Das war ein Demo der BasicLib|von Klaus Bamberger',
                  1, ' OK ', Button);
  SSWiS.Reinit
END BasDem1.
